library IEEE; 
use IEEE.std_logic_1164.all; 

entity bmul32 is   -- 32-bit by 32-bit two's complement multiplier 
 port (a : in  std_logic_vector(31 downto 0);   -- multiplier 
       b : in  std_logic_vector(31 downto 0);   -- multiplicand 
       p : out std_logic_vector(63 downto 0));  -- product 
end entity bmul32; 

architecture circuits of bmul32 is 
 signal zer : std_logic_vector(31 downto 0) := x"00000000";     -- zeros 
 signal mul0: std_logic_vector(2 downto 0); 
 subtype word is std_logic_vector(31 downto 0); 
 type ary is array(0 to 15) of word; 
 signal s : ary;                       -- temp sums 
begin  -- circuits of bmul32 
 mul0 <= a(1 downto 0) & '0'; 
 a0:  entity WORK.badd32 port map( 
             mul0,            b, zer,   s( 0), p( 1 downto  0)); 
stage: for I in 1 to 14 generate
 
as: entity WORK.badd32 port map(a(2*I+1  downto 2*I-1), b, s( I-1), s( I), p( 2*I+1 downto  2*I)); 

             end generate stage; 
			
 a15: entity WORK.badd32 port map( 
             a(31 downto 29), b, s(14), p(63 downto 32) , p(31 downto 30)); 
end architecture circuits;  -- of bmul32 
