`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    22:15:09 04/10/2008 
// Design Name: 
// Module Name:    BoothAlgo 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module BoothAlgo(A,B,Product);
parameter N=31;
input[N:0] A,B;
output[2*N:0] Product;
integer SC,i;
reg[2:0] AC;
reg[N:0] CB;
reg[N:0] BP;
reg[N+1:0] AP;
reg[2*N:0] Product,Mul;

//---------------------------init
always@(A,B)
	begin
		Mul=0;
		AC=0;
		AP[N+1:1]=A;
		AP[0]=0;
		BP=B;
		CB=~B+1;
		SC=0;
		Product=0;
		
		//---------------------
		while(SC<16)
			begin
				Mul=0;
				if (SC==0)
					begin
						AC[2:0]=AP[2:0];
						AP=AP>>1;
					end
				else
					begin
						AC=AC>>2;
						AC[1]=AP[0];
						AC[2]=AP[1];				
					end
				AP=AP>>2;
				AP[N]=AP[N-2];
				AP[N-1]=AP[N-2];		
				
				case(AC)
					3'b000:
						begin
							Mul=0;
							for(i=N+1;i<=2*N;i=i+1)
								Mul[i]=Mul[N];
							Mul=Mul<<(SC*2);
							Product=Product+Mul;
						end
					3'b001:
						begin
							Mul=BP;
							for(i=N+1;i<=2*N;i=i+1)
								Mul[i]=Mul[N];
							Mul=Mul<<(SC*2);
							Product=Product+Mul;
						end
					3'b010:
						begin
							Mul=BP;
							for(i=N+1;i<=2*N;i=i+1)
								Mul[i]=Mul[N];
							Mul=Mul<<(SC*2);
							Product=Product+Mul;
						end
					3'b011:
						begin
							Mul=BP<<1;
							for(i=N+2;i<=2*N;i=i+1)
								Mul[i]=Mul[N+1];
							Mul=Mul<<(SC*2);
							Product=Product+Mul;
						end
					3'b100:
						begin
							Mul=CB<<1;
							for(i=N+2;i<=2*N;i=i+1)
								Mul[i]=Mul[N+1];
							Mul=Mul<<(SC*2);
							Product=Product+Mul;
						end
					3'b101:
						begin
							Mul=CB;
							for(i=N+1;i<=2*N;i=i+1)
								Mul[i]=Mul[N];
							Mul=Mul<<(SC*2);
							Product=Product+Mul;
						end
					3'b110:
						begin
							Mul=CB;
							for(i=N+1;i<=2*N;i=i+1)
								Mul[i]=Mul[N];
							Mul=Mul<<(SC*2);
							Product=Product+Mul;
						end
					3'b111:
						begin
							Mul=0;
							for(i=N+1;i<=2*N;i=i+1)
								Mul[i]=Mul[N];
							Mul=Mul<<(SC*2);
							Product=Product+Mul;
						end
				endcase
				SC=SC+1;
			end
	end
endmodule